﻿Imports System.IO
Imports System.Runtime.Serialization.Formatters.Binary
Imports System.Runtime.Serialization.Formatters.Soap

Public Class Servicos

    ' Serializa um objeto ArrayList para um arquivo binário
    Public Shared Sub BinarySerialize(ByVal lista As ArrayList, ByVal nomeArquivoBinario As String)
        Using str As IO.FileStream = File.Create(nomeArquivoBinario)
            Dim bf As New BinaryFormatter()
            bf.Serialize(str, lista)
        End Using
    End Sub

    ' Deserialize um objeto arrayList de um arquivo binário
    Public Shared Function BinaryDeserialize(ByVal NomeArquivo As String) As ArrayList
        Dim lista As ArrayList = Nothing
        Using str As FileStream = File.OpenRead(NomeArquivo)
            Dim bf As New BinaryFormatter()
            lista = DirectCast(bf.Deserialize(str), ArrayList)
        End Using
        Return lista
    End Function

    ' Serialize um objeto ArrayList para um arquivo SOAP
    Public Shared Sub SoapSerialize(ByVal lista As ArrayList, ByVal nomeArquivoSoap As String)
        Using str As FileStream = File.Create(nomeArquivoSoap)
            Dim sf As New SoapFormatter()
            sf.Serialize(str, lista)
        End Using
    End Sub

    ' Deserialize um objteo ArrayList de um arquivo SOAP
    Public Shared Function SoapDeserialize(ByVal NomeArquivo As String) As ArrayList
        Dim lista As ArrayList = Nothing
        Using str As FileStream = File.OpenRead(NomeArquivo)
            Dim sf As New SoapFormatter()
            lista = DirectCast(sf.Deserialize(str), ArrayList)
        End Using
        Return lista
    End Function

    Public Shared Function LerArquivo(ByVal nomeArquivoBin As String) As String
        Dim fs As New FileStream(nomeArquivoBin, FileMode.Open)
        Dim b(fs.Length - 1) As Byte
        fs.Read(b, 0, b.Length - 1)
        fs.Close()
        fs = Nothing
        Dim dados As String = System.Text.ASCIIEncoding.ASCII.GetString(b)
        Return dados
    End Function

End Class
